package initialize

import (
	"gitea.pena/PenaSide/common/encrypt"
	"github.com/caarlos0/env/v8"
	"github.com/joho/godotenv"
	"log"
)

type Config struct {
	LoggerProdMode bool   `env:"IS_PROD_LOG" envDefault:"false"`
	IsProd         bool   `env:"IS_PROD" envDefault:"false"`
	S3Endpoint     string `env:"S3_ENDPOINT" envDefault:"localhost:9005"`
	S3AccessKey    string `env:"S3_ACCESS_KEY" envDefault:"admin"`
	S3SecretKey    string `env:"S3_SECRET_KEY" envDefault:"admin123"`
	ClientHttpURL  string `env:"CLIENT_HTTP_URL" envDefault:"0.0.0.0:1490"`
	CrtFile        string `env:"CRT" envDefault:"server.crt"`
	KeyFile        string `env:"KEY" envDefault:"server.key"`
	PostgresURL    string `env:"POSTGRES_URL" envDefault:"host=localhost port=35432 user=squiz password=Redalert2 dbname=squiz sslmode=disable"`
	RedisHost      string `env:"REDIS_HOST" envDefault:"localhost:6379"`
	RedisPassword  string `env:"REDIS_PASSWORD" envDefault:"admin"`
	RedisDB        uint64 `env:"REDIS_DB" envDefault:"2"`
	RedirectURL    string `env:"REDIRECT_URL" envDefault:"https://squiz.pena.digital"`
	TrashLogHost   string `env:"TRASH_LOG_HOST" envDefault:"localhost:7113"`
	ExternalCfg    ExternalCfg
}

type ExternalCfg struct {
	EncryptCommon encrypt.Encrypt
}

func LoadConfig() (*Config, error) {
	if err := godotenv.Load(); err != nil {
		log.Print("No .env file found")
	}
	var config Config
	if err := env.Parse(&config); err != nil {
		return nil, err
	}
	return &config, nil
}

const ModuleLogger = "answerer"
