package initialize

import (
	"context"
	dalBS "gitea.pena/SQuiz/answerer/internal/dal"
	"gitea.pena/SQuiz/common/dal"
	"github.com/minio/minio-go/v7"
)

type DALs struct {
	PgDAL     *dal.DAL
	BlobStore *dalBS.Storer
}

func NewDALs(ctx context.Context, cfg Config, minioClient *minio.Client) (*DALs, error) {
	pgDAL, err := dal.New(ctx, cfg.PostgresURL, minioClient)
	if err != nil {
		return nil, err
	}

	blobStore, err := dalBS.New(ctx, minioClient)
	if err != nil {
		return nil, err
	}

	return &DALs{
		PgDAL:     pgDAL,
		BlobStore: blobStore,
	}, nil
}
